<?php
namespace app\workerapi\lists;

use app\common\model\master_worker_register\MasterWorkerRegister;
use app\common\lists\ListsSearchInterface;
use app\common\model\property\PropertyHead;
use app\common\model\works\ServiceWork;
use app\workerapi\logic\SaleLogic;
use think\facade\Db;


/**
 * PropertyHeadLists列表
 * Class PropertyHeadLists
 * @package app\workerapi\lists
 */
class PropertyHeadLists extends BaseWorkerDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2025/02/25 09:29
     */
    public function setSearch(): array
    {
        $sale_id = SaleLogic::getSaleIdByToken($this->params['sale_token']??'00000');
        $this->params['sale_id'] = $sale_id;
        return [
            '=' => ['sale_id'],
            '%like%' => ['property_name', 'village_name', 'head_name'],
        ];
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2025/02/25 09:29
     */
    public function lists(): array
    {
        return PropertyHead::where($this->searchWhere)
            ->field(['*'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2025/02/25 09:29
     */
    public function count(): int
    {
        return PropertyHead::where($this->searchWhere)->count();
    }

}